Subject: Re: [Dime] RFC 3588 (Diameter Base Protocol) - Section 2.1.1. SCTP Guidelines

From: Victor Pascual Avila <[email-masked]>
Date: Mon, 3 May 2010 12:26:44 +0200

Any opinions? Is the below worth to be clarified in 3588bis?

Thanks,
-Victor

On Mon, Apr 26, 2010 at 9:54 AM, Victor Pascual Avila
<[email-masked]> wrote:
> Hi,
>
> Apologies in case this is not the appropriate list for the question
> below-- I'd appreciate pointers to any other list.
>
> RFC 3588 - Section  2.1.1 (SCTP Guidelines) states the following: "To
> prevent blocking: All Diameter nodes SHOULD utilize all SCTP streams
> available to the association to prevent head-of-the-line blocking."
> While RFC 3539 - Section 3.8.1 (Using SCTP Streams to Prevent Head of
> Line Blocking) also addresses multi-streaming, it's not clear to me
> whether:
>
> a) Diameter transactions need to be mapped into SCTP streams (ie; send
> Diameter messages belonging to the same transaction over the same SCTP
> stream and messages belonging to different transactions over different
> SCTP streams-- as long as there are enough available streams)
> b) Ordered vs unordered delivery: for the above mechanism, I
> understand TLS would require ordered delivery. When TLS is not used
> (say, IPSec is used instead), do we really need ordered delivery?
>
> Thanks in advance for any clarification,
> --
> Victor Pascual Ávila
>

-- 
Victor Pascual Ávila

---

From: Victor Fajardo <[email-masked]>
Date: Mon, 3 May 2010 13:41:24 -0400

Hi,

For me I think message ordering and/or delivery is an implementation issue
(and hence SCTP stream assignments/usage as well). There are many ways to go
about this (ordered global rx queues, per-session queues ... etc) and all of
the depends on how you architecture your implementation. This is a good
reason not to have it in a protocol spec.

regards,
victor

On Mon, May 3, 2010 at 6:26 AM, Victor Pascual Avila <
[email-masked]> wrote:

> _______________________________________________
> DiME mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/dime
>

---

From: Stefan Winter <[email-masked]>
Date: Tue, 04 May 2010 07:51:08 +0200

Hi,
 
> For me I think message ordering and/or delivery is an implementation
> issue (and hence SCTP stream assignments/usage as well). There are
> many ways to go about this (ordered global rx queues, per-session
> queues ... etc) and all of the depends on how you architecture your
> implementation. This is a good reason not to have it in a protocol spec.
>

I don't quite understand that. If you leave the decision of message
ordering to the implementation, you can easily run into one
implementation sending its transactions unordered or in different
streams, while the implementation on the other end expects them to come
in ordered and in the same stream. This will lead to poor/no
interoperability between the two implementations. I'd consider this
property to be part of the spec. At the very least, it should be spec'd
that the receiving end MUST be prepared to handle out-of-order or
cross-stream transactions.

Greetings,

Stefan Winter

-- 
Stefan WINTER
Ingenieur de Recherche
Fondation RESTENA - Réseau Téléinformatique de l'Education Nationale et de la Recherche
6, rue Richard Coudenhove-Kalergi
L-1359 Luxembourg

Tel: +352 424409 1
Fax: +352 422473

---

From: Naveen Kottapalli <[email-masked]>
Date: Tue, 4 May 2010 11:27:22 +0100

IMHO we can specify the same as a caution note in the RFC like some of the
SIGTRAN protocols did.

Yours,
Naveen.

---

From: Victor Pascual Avila <[email-masked]>
Date: Tue, 4 May 2010 12:40:18 +0200

IMO rfc4168 is pretty clear on the topic:
http://tools.ietf.org/html/rfc4168#section-5

-Victor

-- 
Victor Pascual Ávila

---

From: Victor Fajardo <[email-masked]>
Date: Tue, 4 May 2010 08:24:15 -0400

Hi Stefan,

I don't mind stating in the spec that a node MUST be prepared to handle
out-of-order messages. What I do mind is stating in the spec how it should
be done. I don't consider the 'how' part a property of the spec.

regards,
victor

On Tue, May 4, 2010 at 8:23 AM, Victor Fajardo <[email-masked]> wrote:

> Hi Stefan,
>
> I don't mind stating in the spec that a node MUST be prepared to handle
> out-of-order messages. What I do mind is stating in the spec how it should
> be done. I don't consider the 'how' part a property of the spec.
>
> regards,
> victor
>
>   On Tue, May 4, 2010 at 1:51 AM, Stefan Winter <[email-masked]>wrote:
>
>>   Hi,
>>

---

From: Victor Fajardo <[email-masked]>
Date: Tue, 4 May 2010 08:34:22 -0400

Hi,

I see. Then I would propose that in the current state of this spec, we can
simply state a minimum (as stefan has mentioned) that a peer MUST be ready
to handle un-ordered messages. Then someone can volunteer a more proper
guideline for SCTP stream usage/assignment either in an errata or an another
draft.

regards,
victor

On Tue, May 4, 2010 at 6:40 AM, Victor Pascual Avila <
[email-masked]> wrote:

> >> Fondation RESTENA - Réseau Téléinformatique de l'Education Nationale et
> de
> >> la Recherche